#!/usr/bin/env python3

import multiprocessing
import sys

def run_compute(num, mod, iter):
    """
    function to elaborate
    """
    res = num
    for i in range(iter):
        res = res * num % mod
    print("compute(" + str(num) + ", " + str(mod) + ", " + str(iter) + ") = " + str(res))

if __name__ == "__main__":
    
    if len(sys.argv) < 3:
        print("USAGE: " + sys.argv[0] + " NUM1[,NUM2,..[NUMn]],MOD,ITER")
        sys.exit(1)

    args = sys.argv[1:]
    
    iter = int(args[len(args) - 1])
    mod  = int(args[len(args) - 2])
    nums = len(args) - 2
    proc = []

    print('ITER = ' + str(iter))
    print('MOD  = ' + str(mod))
    for p in range(nums):
        print('NUM = ' + args[p])
    
    for p in range(nums):
        px = multiprocessing.Process(target=run_compute, args=(int(args[p]),mod,iter))
        proc.append(px)

    for p in range(nums):
        proc[p].start()

    for p in range(nums):
        print('Waiting for process' + str(p))
        proc[p].join()
    
    # all processes finished
    print("Done!")

